/* ============================================================ */
/*   Table: categories                                          */
/* ============================================================ */
create table categories
(
    id                numeric                not null,
    locdir            varchar(50)            null    ,
    category          varchar(50)            null    ,
    mother            numeric                not null,
    url               varchar(50)            null    ,
    urlforced         varchar(50)            null    ,
    constraint PK_CATEGORIES primary key (id)
);

/* ============================================================ */
/*   Table: types                                               */
/* ============================================================ */
create table types
(
    type              numeric                not null,
    typename          varchar(50)            null    ,
    partnumber        numeric                null    ,
    partrefine        varchar(50)            null    ,
    subcat            numeric                null    ,
    nbport            numeric                null    ,
    loadfile          varchar(255)           null    ,
    constraint PK_TYPES primary key (type)
);

/* ============================================================ */
/*   Table: files                                               */
/* ============================================================ */
create table files
(
    site              varchar(200)           not null,
    fic               varchar(255)           not null,
    constraint PK_FILES primary key (site, fic)
);

/* ============================================================ */
/*   Table: ACL                                                 */
/* ============================================================ */
create table ACL
(
    Login             varchar(50)            not null,
    Password          varchar(50)            null    ,
    FName             varchar(50)            null    ,
    LName             varchar(50)            null    ,
    constraint PK_ACL primary key (Login)
);

/* ============================================================ */
/*   Table: admin                                               */
/* ============================================================ */
create table admin
(
    CCident           varchar(50)            not null,
    minport           numeric                not null,
    maxport           numeric                not null,
    nbmaxsites        numeric                not null,
    HTTPport          char(4)                null    ,
    HTTPpasswd        varchar(50)            null    ,
    UPLOADCNXport     numeric                null    ,
    UPLOADSCSport     numeric                null    ,
    UPLOADEMport      numeric                null    ,
    capacity          numeric                null    ,
    closedelay        numeric                null    ,
    DNSname           varchar(50)            null    ,
    constraint PK_ADMIN primary key (CCident)
);

/* ============================================================ */
/*   Table: users                                               */
/* ============================================================ */
create table users
(
    userISP           varchar(50)            not null,
    passISP           varchar(50)            null    ,
    dirISP            varchar(100)           not null,
    maxDirSize        numeric                null    ,
    firstName         varchar(50)            null    ,
    lastName          varchar(50)            null    ,
    streetAddress     varchar(255)           null    ,
    city              varchar(50)            null    ,
    state             varchar(50)            null    ,
    zipCod            varchar(20)            null    ,
    country           varchar(3)             null    ,
    gender            char(1)                null    ,
    birthDate         varchar(10)            null    ,
    interest          varchar(255)           null    ,
    email             varchar(100)           null    ,
    question          varchar(255)           null    ,
    answer            varchar(255)           null    ,
    constraint PK_USERS primary key (userISP)
);

/* ============================================================ */
/*   Table: sites                                               */
/* ============================================================ */
create table sites
(
    author            varchar(50)            null,
    name              varchar(50)            not null,
    locdir            varchar(50)            null,
    category          numeric                null    ,
    email             varchar(50)            null    ,
    password          varchar(50)            null    ,
    proxy             varchar(50)            null    ,
    bitmap            varchar(20)            null    ,
    msg               varchar(255)           null    ,
    urlscol           varchar(127)           null    ,
    urlhttp           varchar(127)           null    ,
    timeout           numeric                null    ,
    nbcnx             numeric                null    ,
    creation          numeric                null    ,
    livinguntil       numeric                null    ,
    lang              varchar(50)            null    ,
    type              numeric                null    ,
    subcat            numeric                null    ,
    subtype           numeric                null    ,
    scs               varchar(255)           null    ,
    capacity          numeric                null    ,
    userISP           varchar(50)            null    ,
    CCident           varchar(50)            not null,
    datcre            char(19)               null    ,
    datmod            char(19)               null    ,
    reg               char(1)                null    ,
    keycode           varchar(50)            null    ,
    DMSid             numeric                not null,
    closedelay        numeric                null    ,
    nblaunch          numeric                null    ,
    autostart         char(1)                null    ,
    state             char(1)                null    ,
    port              numeric                null    ,
    nbport            numeric                null    ,
    loadfile          varchar(255)           null    ,
    scolfile          varchar(255)           null    ,
    constraint PK_SITES primary key (DMSid)
);

/* ============================================================ */
/*   Table: keycode                                             */
/* ============================================================ */
create table keycode
(
    keycode           varchar(50)            not null,
    userISP           varchar(50)            not null,
    datcre            char(19)               null    ,
    period            numeric                null    ,
    maxSites          numeric                null    ,
    mailsent          char(1)                null    ,
    mailperiod        numeric                null    ,
    constraint PK_KEYCODE primary key (keycode, userISP)
);

alter table sites
    add constraint FK_SITES_REF_83_ADMIN foreign key  (CCident)
       references admin (CCident);

alter table keycode
    add constraint FK_KEYCODE_REF_800_USERS foreign key  (userISP)
       references users (userISP);

