/* routines de gestion de repertoire*/

//#define SUN

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

#include <sys/types.h>
#include <sys/stat.h>
#ifdef SUN
#include <sys/dirent.h>
#define direct dirent
#else
#include <sys/dir.h>
#endif
#include <sys/wait.h>

#include <dirent.h>

#define MAXPATH 1024

int statmv;

int killmaj(char *src)
{
  while (*src)
    {
      if (((*src)>='A')&&((*src)<='Z')) (*src)+=32;
      src++;
    }
  return 0;
}

int testmaj(char *src)
{
  while (*src)
    {
      if (((*src)>='A')&&((*src)<='Z')) return 1;
      src++;
    }
  return 0;
}

int movefile(char *infile,char *outfile)
{
  statmv++;
  printf("%s -> %s\n",infile,outfile);
  if (fork()==0)
    {
      execlp("/bin/mv","/bin/mv",infile,outfile,NULL);
      exit(0);
    }
  wait(0);

  return 0;
}
int removedir(char *name)
{
  if (fork()==0)
    {
      execlp("/bin/rmdir","/bin/rmdir",name,NULL);
      exit(0);
    }
  wait(0);
  return 0;
}

void mrgdir(char *src,char *dst)
{
  DIR *d;
  DIR *tst;
  struct dirent *dp;
  struct stat info;
  char name[MAXPATH];
  char curdir[MAXPATH];
  char bufdest[MAXPATH];

  sprintf(curdir,"%s/.",src);
  if ((d=opendir(curdir)))
    {
      while((dp=readdir(d))!=NULL)
	{
	  sprintf(name,"%s/%s",src,dp->d_name);
	  stat(name,&info);
	  if ((info.st_mode&S_IFMT)!=S_IFDIR)
	    {
	      sprintf(bufdest,"%s/%s",src,dp->d_name);
	      killmaj(bufdest);
	      movefile(name,bufdest);
	    }
	  else if ((strcmp(dp->d_name,"."))&&(strcmp(dp->d_name,"..")))
	    {	  
	      sprintf(bufdest,"%s/%s",dst,dp->d_name);
	      killmaj(bufdest);
	      tst=opendir(bufdest);
	      if (tst)
		{
		  closedir(tst);
		  mrgdir(name,bufdest);
		  removedir(name);
		}
	      else
		{
		  movefile(name,bufdest);
		}
	    }
	}
    }
  closedir(d);
}

void killmajdir(char *dir)
{
  DIR *d;
  DIR *tst;
  struct dirent *dp;
  struct stat info;
  char name[MAXPATH];
  char curdir[MAXPATH];
  char bufdest[MAXPATH];
  sprintf(curdir,"%s/.",dir);
  
  if ((d=opendir(curdir)))
    {
      while((dp=readdir(d))!=NULL)
	{
	  sprintf(name,"%s/%s",dir,dp->d_name);
	  stat(name,&info);
	  if ((info.st_mode&S_IFMT)!=S_IFDIR)
	    {
	      if (testmaj(dp->d_name))
		{
		  sprintf(bufdest,"%s/%s",dir,dp->d_name);
		  killmaj(bufdest);
		  movefile(name,bufdest);
		}
	    }
	  else if ((strcmp(dp->d_name,"."))&&(strcmp(dp->d_name,".."))
		   &&(testmaj(dp->d_name)))
	    {	  
	      sprintf(bufdest,"%s/%s",dir,dp->d_name);
	      killmaj(bufdest);
	      tst=opendir(bufdest);
	      if (tst)
		{
		  closedir(tst);
		  mrgdir(name,bufdest);
		  removedir(name);
		}
	      else
		{
		  movefile(name,bufdest);
		}
	    }
	}
    }
  closedir(d);
  if ((d=opendir(curdir)))
    {
      while((dp=readdir(d))!=NULL)
	{
	  sprintf(name,"%s/%s",dir,dp->d_name);
	  stat(name,&info);
	  if (((info.st_mode&S_IFMT)==S_IFDIR)&&
	      (strcmp(dp->d_name,"."))
	      &&(strcmp(dp->d_name,"..")))
	    {    
	      sprintf(bufdest,"%s/%s",dir,dp->d_name);
	      killmajdir(bufdest);
	    }
	}
    }
  closedir(d);
}

int startkillmaj(char *dir)
{
  statmv=0;
  killmajdir(dir);
  printf("%d files moved\n",statmv);
  return 0;
}

int main(int argc,char **argv)
{
  printf("killmaj - august 99 - Sylvain Huet\n");
  printf("----------------------------------\n");
  if (argc>1) chdir (argv[1]);
  startkillmaj(".");
  return 0;
}
