/**************************************************
 * 
 *
 **************************************************
 * This code was created by Peter Harvey @ CodeByDesign. 
 * Released under GPL 31.JAN.99
 *
 * Contributions from...
 * -----------------------------------------------
 * Peter Harvey		- pharvey@codebydesign.com
 **************************************************/
#ifndef classODBCConfig_included
#define classODBCConfig_included

#include <qmessagebox.h>
#include <qpixmap.h>
#include <qdialog.h>
#include <qtabbar.h>
#include <qframe.h>
#include <qpixmap.h>
#include <qlayout.h>

#include "classUserDSN.h"
#include "classSystemDSN.h"
#include "classDrivers.h"
#include "classAbout.h"
#include "classTracing.h"
#include "classStats.h"

class classODBCConfig : public QWidget
{
    Q_OBJECT

public:
    enum tabs { TAB_USERDSN, TAB_SYSTEMDSN, TAB_DRIVERS, TAB_STATS, TAB_TRACING, TAB_ABOUT };

    classODBCConfig( QWidget* parent = NULL, const char* name = NULL );
    virtual ~classODBCConfig();

    void resizeEvent( QResizeEvent * );

protected slots:
    void TabChanged(int);

protected:
    QTabBar* tbTabBar;
    QFrame* fraTabFrame;

private:
    classUserDSN    *pUserDSN;
    classSystemDSN  *pSystemDSN;
    classDrivers    *pDrivers;
    classStats      *pStats;
    classTracing    *pTracing;
    classAbout      *pAbout;

    void LoadState();
    void SaveState();

};
#endif 


